/******************************************************************************
*
* AntiMafia
* Copyright (C) 2002 by [epidemiC] AntiMafia
* Newtella
* Copyright (C) 2000 by Newtella Inc.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
******************************************************************************/


// ConfigPage.cpp : implementation file
//

#include "stdafx.h"
#include "AntiMafia.h"
#include "Core\common.h"
#include "Core\Buffer.h"
#include "Core\Object.h"
#include "Core\List.h"
#include "Core\String.h"
#include "Core\FileWorker.h"
#include "Core\Connection.h"
#include "Core\GnutellaWorker.h"
#include "Core\Base.h"
#include "ConfigPage.h"
#include "ConfigConnectionPage.h"
#include "ConfigDownloadPage.h"
#include "ConfigAdvancedNetworkPage.h"

/////////////////////////////////////////////////////////////////////////////
// CConfigPage property page

IMPLEMENT_DYNCREATE(CConfigPage, CPropertyPage)

CConfigPage::CConfigPage() : CPropertyPage(CConfigPage::IDD)
{
	//{{AFX_DATA_INIT(CConfigPage)
	//}}AFX_DATA_INIT
	m_psp.dwFlags &= ~PSH_HASHELP;
}

CConfigPage::~CConfigPage()
{
}

void CConfigPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConfigPage)
	DDX_Control(pDX, IDC_ERRORLISTBOX, m_ErrorList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConfigPage, CPropertyPage)
	//{{AFX_MSG_MAP(CConfigPage)
	ON_BN_CLICKED(IDC_WIZARD, OnWizard)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConfigPage message handlers


void CConfigPage::OnWizard() 
{
	CPropertySheet wizard;
	CConfigConnectionPage ConfigConnectionPage;
	CConfigDownloadPage ConfigDownloadPage;
	ConfigConnectionPage.parentSheet = &wizard;
	ConfigDownloadPage.parentSheet = &wizard;

	ConfigConnectionPage.m_Type = global.options.connectionType;
	ConfigDownloadPage.m_DownloadDir = global.options.downloadDir;

	wizard.AddPage(&ConfigConnectionPage);
	wizard.AddPage(&ConfigDownloadPage);
	wizard.SetWizardMode();
	if (wizard.DoModal() == IDOK)
	{
		global.options.downloadDir = ConfigDownloadPage.m_DownloadDir;
		gnutella->BuildFileIndex();

		global.options.connectionType = ConfigConnectionPage.m_Type;
	}
}

void CConfigPage::OnAdvanced() 
{
	CPropertySheet wizard;
	CConfigConnectionPage ConfigConnectionPage;
	CConfigDownloadPage ConfigDownloadPage;
	CConfigAdvancedNetworkPage ConfigAdvancedNetworkPage;
	ConfigConnectionPage.parentSheet = &wizard;
	ConfigDownloadPage.parentSheet = &wizard;
	ConfigAdvancedNetworkPage.parentSheet = &wizard;

	ConfigConnectionPage.m_Type = global.options.connectionType;
	ConfigConnectionPage.m_Speed = global.options.connectionSpeed;
	ConfigDownloadPage.m_DownloadDir = global.options.downloadDir;
	if (global.options.forcedIP)
		ConfigAdvancedNetworkPage.m_ForceLocalIP = inet_iptoa(global.options.forcedIP);
	else
		ConfigAdvancedNetworkPage.m_ForceLocalIP = "";
	ConfigAdvancedNetworkPage.m_ListenPort = ntohs(global.options.listenPort);
	WORD oldListenPort = global.options.listenPort;
	ConfigAdvancedNetworkPage.m_MaxResults = global.options.searchLimit;

	wizard.AddPage(&ConfigConnectionPage);
	wizard.AddPage(&ConfigDownloadPage);
	wizard.AddPage(&ConfigAdvancedNetworkPage);
	//cpropertysheet
	wizard.SetTitle("Options");
	if (wizard.DoModal() == IDOK)
	{
		global.options.downloadDir = ConfigDownloadPage.m_DownloadDir;
		global.options.forcedIP = inet_addr(ConfigAdvancedNetworkPage.m_ForceLocalIP);
		if (global.options.forcedIP == INADDR_NONE)
			global.options.forcedIP = 0;
		global.options.searchLimit = ConfigAdvancedNetworkPage.m_MaxResults;
		gnutella->BuildFileIndex();

		if (global.options.listenPort != htons(ConfigAdvancedNetworkPage.m_ListenPort))
		{
			global.options.listenPort = htons(ConfigAdvancedNetworkPage.m_ListenPort);
			if (!gnutella->SetListenPort())
			{
				char stemp[MAX_TEMPBUF_LEN];
				sprintf(stemp, "Could not set listening port to %d.\nReverting to %d", ntohs(global.options.listenPort), ntohs(oldListenPort));
				MessageBox(stemp, "Error", MB_ICONSTOP | MB_OK);
				global.options.listenPort = oldListenPort;
			}
		}

		global.options.connectionSpeed = ConfigConnectionPage.m_Speed;
		global.options.connectionType = ConfigConnectionPage.m_Type;
	}
}

