/******************************************************************************
*
* AntiMafia
* Copyright (C) 2002 by [epidemiC] AntiMafia
* Newtella
* Copyright (C) 2000 by Newtella Inc.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
******************************************************************************/


#define MSG_ERROR WM_USER+41
#define CHANGED_FOUND_FILES WM_USER+31 //FIXME
#define MyPathAddBackslash(s) if (s[strlen(s)-1] != '\\') strcat(s, "\\") ;

enum MyDebugTypes
{
	MyERROR, MyWARNING, MyINFORMATION
};
enum LogTypes
{
	LOGTYPE_DEFAULT, LOGTYPE_BETA, LOGTYPE_SEARCHES, LOGTYPE_DOWNLOADS, LOGTYPE_UPLOADS
};


class Options
{
public:
	Options();
	~Options();
public:
	int searchTTL, pingTTL;
	int connectionSpeed;
	int searchLimit;
	BOOL connectAutomatically, acceptIncoming, killBuggyClients, displayAll ;
	int minConnections, maxConnections;
	int maxDownloads, maxUploadstotal, maxUploadsperclient;
	int maxUploadBandwidth;
	DWORD forcedIP;
	WORD listenPort;
	String shareDir, downloadDir, searchTypes, ignoreResults, programDir;
	String connectionType;
};
class Stats : public Object
{
public:
	Stats();
	~Stats();
	BOOL Dump(FILE *file);
public:
	int sent, received, perSecond;
	int pings, pongs, searches, searchresponses, pushrequests;
};
class Global
{
public:
	Global();
	~Global();
public:
	HWND hWnd;
	HINSTANCE hInst;
	Options options;
	Stats stats;
	GLUID sessionGUID;
	DWORD localIP;
	BOOL clientFirewalled;
	int totalFileCount, totalFileSize;
	int searchFileCount ;
	DWORD connectionID, AntiMafiaConnectionID ;
	int WindowX, WindowY, WindowCX, WindowCY, WindowZoomed ;
	int SearchFile, SearchSize, SearchSpeed, SearchLocation, SearchReceived ;
	int ConnectionIP, ConnectionStatus, ConnectionPackets, ConnectionBandwidth ;
	int DownloadFile, DownloadSize, DownloadStatus, DownloadSpeed, DownloadServer ;
	int UploadFile, UploadSize, UploadStatus, UploadSpeed, UploadDownloader ;

};

enum ResolveTypes
{
	RESOLVE_NONE, RESOLVE_ADDRESSTONAME, RESOLVE_NAMETOADDRESS
};

class HostInfo : public Object
{
public:
	HostInfo();
	~HostInfo();
	BOOL Dump(FILE *file);
	BOOL Serialize(FILE *file, BOOL store=FALSE);
public:
	DWORD ip;
	WORD port;
	DWORD time;
	int fileCount, filesTotalsize, hops;
	String hostName;
	ResolveTypes resolveType;
	BOOL resolved;
};

class RoutingInfo : public Object
{
public:
	RoutingInfo();
	~RoutingInfo();
public:
	int function;
	DWORD time;
	DWORD id;
	GLUID guid;
	HASH hash;
};

extern FILE *protocol;
extern char ods[4096];
extern Global global;
extern GnutellaWorker *gnutella;
extern List errors;


BOOL myhash(BYTE *buf, int buflen, HASH hash);
char *inet_iptoa(DWORD ip, WORD port=0);
char *WSAErrorString(int e);
BOOL GetLine(const char *src, int len, int pos, char *target);
BOOL GetWord(const char *src, int len, int pos, char *target);

