/******************************************************************************
*
* AntiMafia
* Copyright (C) 2002 by [epidemiC] AntiMafia
* Newtella
* Copyright (C) 2000 by Newtella Inc.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
******************************************************************************/



enum ConnectionState
{
	GS_UNUSED, GS_WAITINGCONNECT, GS_CONNECTED, GS_QUEUED, GS_COMPLETE, GS_CANCELLED, GS_FAILED, GS_DISKERROR, GS_NEEDOVERWRITE, GS_WAITINGPUSH, GS_WAITINGGIV, GS_WAITINGPUSHGET, GS_FILENOTFOUND, GS_BUSY, GS_TIMEOUT
};
enum ConnectionType
{
	CT_NONE, CT_INCOMING, CT_OUTGOING, CT_GET, CT_SEND, CT_TIME
};
enum Response
{
	RC_INVALID, RC_200, RC_206, RC_400, RC_404, RC_503
};

class Packet : public Object
{
public:
	Packet();
	~Packet();
public:
	int time;
	Buffer data;
};

#define conIP address.sin_addr.s_addr
#define conPort address.sin_port

class ConnectionInfo : public Object
{
public:
	ConnectionInfo();
	~ConnectionInfo();
public:
	DWORD id, relatedID;
	ConnectionState state;
	ConnectionType type;
	Response responseCode;

	int sent, received, dropped;
	DWORD lastTime;
	BOOL temporary;
	DWORD speed;

	SOCKADDR_IN address;
//		struct sockaddr_in address;

	FileInfo fi;
	int transmitted;
	BOOL headerTransmitted;

	DWORD speeds[8], speedIndex, speedData, speedTime;
	DWORD limitData;
};
class Connection : public ConnectionInfo
{
	friend class GnutellaWorker;
public:
	Connection();
	~Connection();
	BOOL CloseSocket();
	BOOL ResetBuffer();
	int Send(const char *buf, int len);
	int SendPacket(const char *buf, int len);
	int ReceivePacket(char *buf, int len);
	int Receive(char *buf, int len);
	BOOL SetBandwidthLimit(int kbytes);
	BOOL ComputeSpeed(DWORD timenow);
	BOOL BandwidthLimitReached() { return(limitData && speedData >= limitData); }
//	BOOL RemainingToLimit() { return( (limitData ? (limitData - speedData) : (999999999)) ); }
	DWORD RemainingToLimit() { return( (limitData ? (limitData - speedData) : (999999999)) ); }
	BOOL Serialize(FILE *file, BOOL store);
	BOOL GetIp(unsigned char *ip) const;
public:
	Buffer buffer;
	char *b;
	DWORD bufferLength;
	List packets;

	SOCKET socket;
};

