/******************************************************************************
*
* AntiMafia
* Copyright (C) 2002 by [epidemiC] AntiMafia
* Newtella
* Copyright (C) 2000 by Newtella Inc.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
******************************************************************************/


#define NODE_UNUSED -1

enum DataType
{
	DATATYPE_HOSTINFO=1, DATATYPE_CONNECTION, DATATYPE_FILEINFO, DATATYPE_STRING
};

class Node
{
	friend class List;
public:
	Node();
	Node(int desc, Object *data);
	~Node();
	BOOL Set(int desc, Object *data);
private:
	BOOL Set_Private(int desc, Object *newdata);
private:
	Object *data;
	int descriptor;
	Node *next, *previous;
//	char tempbuf[4096] ;
};

class List
{
public:
	List();
	~List();
	BOOL Reset();
	BOOL Add(Object *data);
	BOOL Add(int desc, Object *data);
	BOOL Remove(Object *ob);
	BOOL Unlink(Object *ob);
	BOOL SetMaxNodes(unsigned int max);
	Object *GetData(int desc);
	Object *operator[](int i);
	BOOL SetCursor(int i);
	Object *GetFirst(BOOL spool=TRUE);
	Object *GetNext(BOOL spool=TRUE);
	Object *GetLast(BOOL spool=TRUE);
	Object *GetPrevious(BOOL spool=TRUE);
	int GetPreviousDescriptor();
	Object *GetNextByDescriptor(int desc, BOOL spool=TRUE);
	Object *GetRandom();
	inline int Count() { return(count); }
	inline void SetCurrentDescriptor(int desc) { if (current) current->descriptor = desc ; }
	BOOL Dump(FILE *file, int n=0);
	BOOL Serialize(FILE *file, BOOL store=FALSE);
	BOOL SetDataType(DataType d);
	int CheckMemErrors() ;
private:
	BOOL Reset_Private();
private:
	DataType dt;
	unsigned int count, maxNodes;
	Node *first, *last;
	Node *current;
};



