// NewAction.cpp : implementation file
//

#include "stdafx.h"
#include "AntiMafia.h"
#include "Core\common.h"
#include "Core\Buffer.h"
#include "Core\Object.h"
#include "Core\String.h"
#include "Core\List.h"
#include "Core\FileWorker.h"
#include "Core\Connection.h"
#include "Core\GnutellaWorker.h"
#include "Core\Base.h"
#include "NewAction.h"
#include "Action.h"
#include "MyTime.h"
#include "ActionManager.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNewAction property page

IMPLEMENT_DYNCREATE(CNewAction, CPropertyPage)

CNewAction::CNewAction() : CPropertyPage(CNewAction::IDD)
{
	//{{AFX_DATA_INIT(CNewAction)
	m_sActionName = _T("");
	m_sDescription = _T("");
	m_sPort = _T("");
	m_sSite = _T("");
	m_sWhenDate = 0;
	m_sWhenTime = 0;
	m_duration = 0;
	//}}AFX_DATA_INIT
}

CNewAction::~CNewAction()
{
}

void CNewAction::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNewAction)
	DDX_Text(pDX, IDC_ACTIONNAME_EDIT, m_sActionName);
	DDX_Text(pDX, IDC_DESCRIPTION_EDIT, m_sDescription);
	DDX_Text(pDX, IDC_PORT_EDIT, m_sPort);
	DDX_Text(pDX, IDC_SITE_EDIT, m_sSite);
	DDX_DateTimeCtrl(pDX, IDC_WHEN_DATE, m_sWhenDate);
	DDX_DateTimeCtrl(pDX, IDC_WHEN_TIME, m_sWhenTime);
	DDX_Text(pDX, IDC_DURATION, m_duration);
	DDV_MinMaxInt(pDX, m_duration, 0, 1200);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CNewAction, CPropertyPage)
	//{{AFX_MSG_MAP(CNewAction)
	ON_BN_CLICKED(IDC_SHARE_BUTTON, OnShareButton)
	ON_BN_CLICKED(IDC_BTNTEST, OnBtntest)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNewAction message handlers

void CNewAction::OnShareButton() 
{
	unsigned int port;
	CTime& d = m_sWhenDate;
	CTime& t = m_sWhenTime;
	CTime now = CMyTime::GetCurrentTime();
	DWORD idError = 0;
	CString errMsg;

	UpdateData(TRUE);

	CTime when(d.GetYear(), d.GetMonth(), d.GetDay(), t.GetHour(), 
		t.GetMinute(), t.GetSecond());
	port = atoi(m_sPort);

	if (m_sActionName.IsEmpty())
	{
		idError = IDC_ACTIONNAME_EDIT;
		errMsg = "Enter an action name, please";
	}
	else if(m_sSite.IsEmpty())
	{
		idError = IDC_SITE_EDIT;
		errMsg = "Why didn't you specify the target?";
	}
	else if(m_sPort.IsEmpty() || (port <= 0 || port > 65535))
	{
		idError = IDC_PORT_EDIT;
		errMsg = "You must specify a valid port number";
	}
	else if(when < now)
	{
		CTime today(now.GetYear(), now.GetMonth(), now.GetDay(), 0, 0, 0);
		CTime actionDay(when.GetYear(), when.GetMonth(), when.GetDay(), 0, 0, 0);
		if (today > actionDay)
			idError = IDC_WHEN_DATE;
		else 
			idError = IDC_WHEN_TIME;
		errMsg = "It's impossible to schedule an action in the past";
	}
	else if(m_duration <= 0)
	{
		idError = IDC_DURATION;
		errMsg = "Please, specify a duration greater than zero";
	}
	else if(m_sDescription.IsEmpty())
	{
		idError = IDC_DESCRIPTION_EDIT;
		errMsg = "It would be better to enter a description, don't you think?";
	}
	if (idError != 0)
	{
		::MessageBeep(MB_ICONASTERISK);
		AfxMessageBox(errMsg, MB_OK | MB_SETFOREGROUND | MB_ICONASTERISK);
		GetDlgItem(idError)->SetFocus();
		return;
	}

	Action a(m_sActionName, m_sSite, port, m_sDescription, when, m_duration);
	a.MakeLove(global.options.downloadDir);
	gnutella->BuildFileIndex();
	ActionManager::Instance()->Synchronize();
}

BOOL CNewAction::OnInitDialog() 
{
	
	m_sWhenDate = CMyTime::GetUTime();
	m_sWhenTime = CMyTime::GetUTime();
	
	CPropertyPage::OnInitDialog();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CNewAction::OnBtntest() 
{
	CFileDialog dlg(TRUE);
	
	if (IDOK == dlg.DoModal())
	{
		Action a(dlg.GetPathName());
		AfxMessageBox(a.GetName());
	}
}
